/* -*- MaTX -*-
 *
 * tmd00005.h: TMD No. tmd00005 (ưϤοưθַᵡ)
 *             إåե
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/04>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00005.h,v 1.8 1999/05/31 03:43:13 kiyota Exp $
 */

#ifndef _TMD00005_H
#define _TMD00005_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00005_USER_H
#include TMD00005_USER_H
#endif /* TMD00005_USER_H */

#ifndef TMD00005_MM
#define TMD00005_MM "tmd00005.mm"
#endif /* !TMD00005_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00005(var) _tmd00005_ ## var
#else /* ! TMD_ANSI */
#define tmd00005(var) _tmd00005_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00005(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ֡w,uz,y μο
#define TMD00005_DIM_STATE 4
#define TMD00005_DIM_INPUT_W 1
#define TMD00005_DIM_INPUT_U 1
#define TMD00005_DIM_OUTPUT_Z 1
#define TMD00005_DIM_OUTPUT_Y 1
#define TMD00005_DIM_ALL_IOS (TMD00005_DIM_INPUT_W+TMD00005_DIM_INPUT_U+TMD00005_DIM_OUTPUT_Z+TMD00005_DIM_OUTPUT_Y)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00005(xx) [xx(1:TMD00005_DIM_STATE)]
#define chop_other_state_tmd00005(xx) [xx(TMD00005_DIM_STATE+1:)]
#define chop_input_w_tmd00005(wul) [wul(1:TMD00005_DIM_INPUT_W)]
#define chop_input_u_tmd00005(wul) [wul(TMD00005_DIM_INPUT_W+1:TMD00005_DIM_INPUT_W+TMD00005_DIM_INPUT_U)]

// ǥʪѥ᡼
TMD_EXTERN Real tmd00005(JM), tmd00005(DM), tmd00005(JT), tmd00005(DT);
TMD_EXTERN Real tmd00005(KC), tmd00005(DC), tmd00005(KV), tmd00005(l);
// ư礭
TMD_EXTERN Real tmd00005(f1), tmd00005(f2), tmd00005(f3), tmd00005(f4), tmd00005(f5);
TMD_EXTERN Real tmd00005(f6), tmd00005(f7), tmd00005(f8), tmd00005(f9), tmd00005(f10);

// ֶɽηޥȥꥯ
TMD_EXTERN Matrix tmd00005(A), tmd00005(B1), tmd00005(B2), tmd00005(C1), tmd00005(C2);
TMD_EXTERN Matrix tmd00005(D11), tmd00005(D12), tmd00005(D21), tmd00005(D22);

// ѥåե饰: 1 ưʤ; 0 Ϥ
#ifdef TMD_DISABLE_HALIST
#define TMD00005_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00005_DISABLE_HALIST
TMD_EXTERN Integer tmd00005_flag;
#endif /* TMD00005_DISABLE_HALIST */

// ؿ
#if !defined(TMD_USER_MM) && !defined(TMD00005_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00005_DIVIDED_COMPILE)
#include TMD00005_MM
#else /* !(!TMD_USER_MM && !TMD00005_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00005_DIVIDED_COMPILE) */
void init_tmd00005(/* nominal_flag, const_params_flag, */ ...); // require TMD00005_MM;
Matrix diff_tmd00005(/* t, x, wu */); // require TMD00005_MM;
Matrix output_tmd00005(/* t, x, wu */); // require TMD00005_MM;
#endif /* !TMD_USER_MM && !TMD00005_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00005_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00005_H */
